unit HanoiU;                                                // Dammeier 01.11.01

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin;

type
  TPlatz = array ['A'..'C'] of Integer;          // die 3 Trme

type
  TForm1 = class(TForm)
    EdZahl: TEdit;
    Button1: TButton;
    LaTitel: TLabel;
    Label2: TLabel;
    LaCount: TLabel;
    SpDelay: TSpinEdit;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    Count: Integer;
    Posit: TPlatz;                               // y-Positionen der 3 Trme
    Hoehe: TPlatz;                               // Hhen der 3 Trme
    tRadi, tHoch, tUntn: Integer;
    sRadi, sHoch: Integer;                       // Scheibendaten
    procedure Move (z, g: Integer; von, nach, hilf: Char);
    procedure LegeScheibe (g: Integer; von, nach: Char);
    procedure Scheibe (g: Integer; Platz: Char; Co: TColor);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormResize(Sender: TObject);
begin
  Posit ['A'] := ClientWidth div 4 * 1;          // linke    Position
  Posit ['B'] := ClientWidth div 4 * 2;          // mittlere Position
  Posit ['C'] := ClientWidth div 4 * 3;          // rechte   Position
  tRadi := ClientWidth div 9;                    // Turm-Radius
  tHoch := ClientHeight div 4 * 3;               // Turm-Hhe
  tUntn := ClientHeight div 16 * 15;             // Turm-Unterkante
end;

procedure TForm1.Button1Click(Sender: TObject);
var Zahl, i: Integer;
begin
  Zahl := StrToIntDef (EdZahl.Text, 3);          // Scheibenzahl
  sHoch := tHoch div Zahl;                       // Scheibenhhe
  sRadi := tRadi div Zahl;                       // Scheibenradius
  Hoehe ['A'] := 0;
  Hoehe ['B'] := Zahl;                           // unsichtbarer Vorrat
  Hoehe ['C'] := 0;
  Repaint;                                       // Canvas lschen
  for i := Zahl downto 1 do                      // Anfangsturm
    Move (1, i, 'B', 'A', 'C');                  //   in 'A' zeichnen
  Count := 0;
  Move (Zahl, Zahl, 'A', 'C', 'B');              // Turm bewegen
  LaCount.Caption := IntToStr (Count);
end;

procedure TForm1.Move (z, g: Integer; von, nach, hilf: Char);
begin                        // Bewege Turm von z Scheiben der Gre g
  if z = 1
  then begin
//         Box.Items.Add (von + ' -->> ' + nach);  // alte Textausgabe
         Count := Count + 1;                     // Zugzhler erhhen
         LegeScheibe (g, von, nach);             // Anzeige
         Sleep (SpDelay.Value * 10);             // Warte
         Application.ProcessMessages;            // Erlaube Bedienung
       end
  else begin
        Move (z-1, z-1, von, hilf, nach);        // Teilturm auf Hilf
        Move (  1, z,   von, nach, hilf);        // Unterscheibe
        Move (z-1, z-1, hilf, nach, von);        // Teilturm auf Ziel
      end;
end;

procedure TForm1.LegeScheibe (g: Integer; von, nach: Char);
begin
  Hoehe[von ] := Hoehe[von ] - 1;
  Scheibe (g, von,  Color);                      // wegnehmen
  Scheibe (g, nach, clBlack);                    // hinlegen
  Hoehe[nach] := Hoehe[nach] + 1;
end;

procedure TForm1.Scheibe (g: Integer; Platz: Char; Co: TColor);
var x, y, r: Integer;
begin
  r := sRadi * g;
  x := Posit [Platz];
  y := tUntn - Hoehe [Platz] * sHoch;
  Canvas.Pen.Color := Co;
  Canvas.Brush.Color := Co;
  Canvas.Rectangle (x - r, y, x + r, y - sHoch);
end;

end.
